// file      : meta/polymorphic-p.hxx
// author    : Boris Kolpackov <boris@kolpackov.net>
// copyright : Copyright (c) 2008 Boris Kolpackov
// license   : GNU GPL v2; see accompanying LICENSE file

#ifndef META_POLYMORPHIC_HXX
#define META_POLYMORPHIC_HXX

#include "class-p.hxx"
#include "remove-cv.hxx"

namespace meta
{
  template <typename CVX>
  struct polymorphic_p
  {
    typedef typename remove_cv<CVX>::r X;

    template <typename Y, bool C>
    struct impl
    {
      static const bool r = false;
    };

    template <typename Y>
    struct impl<Y, true>
    {
      struct t1: Y
      {
        t1 ();
      };

      struct t2: Y
      {
        t2 ();

        virtual
        ~t2 () throw ();
      };

      static const bool r = sizeof (t1) == sizeof (t2);
    };

    static const bool r = impl<X, class_p<X>::r>::r;
  };
}

#endif // META_POLYMORPHIC_HXX
